mod Ex03b

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  3. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 5.10.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (parovacia funkcia, aritmetizacia, 'course of values 
  recursion' ). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
   \item \para Subor \it  msyntax.cl  \end obsahuje syntax systemu CL. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Odovzdat do 11.10.2008 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Pairing Function and Arithmetization.  \end 

rem 
  \para \bf  Subsection. Catalan Pairing Function.  \end See the section \it  
  3.2 Course of Values Recursion  \end in [2]. 

rem 
  \para \bf  [CL] Remark.  \end The Catalan pairing function \ft x,y \end is 
  pre-defined in CL. 

rem 
  \para \bf  Basic properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 = y1,y2 -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < x,y & y < x,y
  \end
  \eq* 
    x = 0 \/ \e y\e z x = y,z
  \end

rem 
  \para \bf  Ordering properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 < y1,y2 <-> 
    |x1,x2| < |y1,y2| \/ |x1,x2| = |y1,y2| & (x1 < y1 \/ x1 = y1 & x2 < y2)
  \end
  \para where \ft |x| \end is the pair size function defined in the module \it  
  Standard  \end. 

rem 
  \para \bf  [CL] Remark.  \end The membership predicate \ft x in y \end, where 
  \eq* 
    x in y <-> \e i(i < L(y) & x = Tex_f2_pp_sub(y,i))
  \end
  \para is pre-defined in CL. Notation for its negation is \ft x !in y \end. 

rem 
  \para \bf  Bounded quantification with membership predicate.  \end Note that 
  we have 
  \eq* 
    x in y -> x < y
  \end
  \para Consequently, existential and universal quantifiers in contexts like 
  \eq* 
    \e x(x in y & Tex0_dotsc)
  \end
  \eq* 
    \a x(x in y -> Tex0_dotsc)
  \end
  \para are in fact bounded. Such quantifiers can be used in explicit 
  definitions of predicates with bounded formulas. 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para bounded quantifiers \ft \eb y y in x: R \end and 
         \ft \ab y y in x: R \end 
   \item \para \header* pred/2 Q  \end explicit definitions of predicates 
         \def 
           pred R 
           R(x) <-> \eb y y in x: Q(x,y)
         \end
         \def 
           pred R 
           R(x) <-> 
             \ab y y in x: Q(x,y)
         \end
  \end

